
module type StateSig =
sig
  type t

  val create : string -> t
  val id : t -> string
  val compare : t -> t -> int
  val print : t -> unit
  val print_start : t -> unit
end

module State =
struct
  type t = State of string

  let create x = State(x)
  let id = function State(x) -> x
  let compare = compare
  let print = function State(x) -> Printf.fprintf stdout "state %s\n" x
  let print_start = function State(x) -> Printf.fprintf stdout "start %s\n" x
end
