(* lexer.mll - (C) 2002 by Roberto Raggi, Emilio Tuosto *)

(* $Id: lexer.mll,v 1.1.1.1 2002/06/07 15:44:08 etuosto Exp $ *)

{
open Parser
open Parserdecls
exception Eof  
}

rule token = parse
    [ ' ' '\t' ]		 { token lexbuf }
  | '\n'                         { line_number := !line_number + 1;
                                   token lexbuf }
  | '#' [ ^ '\n' ]*		 { token lexbuf }
  | "state"			 { STATE }
  | "start"			 { START }
  | [ '0'-'9' ]+		 { INT(int_of_string(Lexing.lexeme lexbuf)) }
  | [ 'A'-'Z' 'a'-'z' '0'-'9' ]+ { ID(Lexing.lexeme lexbuf) }
  | '"' [ ^ '"' ]+ '"'           { ID(Lexing.lexeme lexbuf) }
  | "->"			 { ARROW }
  | eof				 { EOF }
