/* parser.mly - (C) 2002 by Roberto Raggi, Emilio Tuosto */

/* $Id: parser.mly,v 1.1.1.1 2002/06/07 15:44:08 etuosto Exp $ */

%{

open Ast
open Parserdecls
open Utils

%}

%token <int> INT
%token <string> ID 
%token EOL 
%token ARROW
%token STATE
%token START
%token EOF


%start main

%type <Ast.decl> main

%%

main	
	: decl_start decl_state_list decl_arrow_list EOF 
          {
	    DeclAutoma($1, $2, $3) 
	  }
	;

decl_start
	: START ID			{ DeclStart $2 }
	;

decl_state_list
	: decl_state 			{ DeclStateList [$1] }
	| decl_state_list decl_state	
	    { 
	      match $1 with 
		  DeclStateList(l) -> DeclStateList(l @ [$2])
		| _ -> failwith "!!!" 
	    }
	;

decl_state
        : STATE ID { DeclState $2 }
	;

label
        : ID                                            { $1 }
	;

decl_arrow
	: ID ARROW ID label { DeclArrow($1, $3, $4) }
	;

decl_arrow_list
 	: decl_arrow 					{ DeclArrowList [$1] }
	| decl_arrow_list decl_arrow 			
	    { 
	      match $1 with
		  DeclArrowList l -> DeclArrowList(l @ [$2])
		| _ -> failwith "expect decl arrow list!!"
	    }
	;


%%


