(* $Id$ *)

{
open Parser
open Parserdecls
exception Eof  
}

rule token = parse
    [ ' ' '\t' ]		 { token lexbuf }
  | '\n'                         { line_number := !line_number + 1;
                                   token lexbuf }
  | '#' [ ^ '\n' ]*		 { token lexbuf }
  | "define"			 { DEFINE }
  | "build"			 { BUILD }
  | "write_hd"			 { WRITE_HD }
  | "const"			 { CONST }
  | "nil"			 { NIL }
  | "tau"			 { TAU }
  | "|"				 { PIPE }
  | "."				 { DOT }
  | "+"				 { PLUS }
  | ","				 { COMMA }
  | "="				 { EQ }
  | "?"				 { IN }
  | "!"				 { OUT }
  | "("				 { LPAREN }
  | ")"				 { RPAREN }
  | "["				 { LBRACKET }
  | "]"				 { RBRACKET }
  | [ '0'-'9' ]+		 { INT(int_of_string(Lexing.lexeme lexbuf)) }
  | [ 'A'-'Z' 'a'-'z' '0'-'9' ]+ { ID(Lexing.lexeme lexbuf) }
  | '"' [ ^ '"' ]+ '"'           { ID(Lexing.lexeme lexbuf) }
  | eof				 { EOF }

