
open Ast
open Parserdecls
open Build


(* [read_file filename] parse the contents of file filename and returns
 * the abstract syntax tree
 *)
let read_file filename =
  let lexbuf = Lexing.from_channel (open_in filename)
  in Parser.commands Lexer.token lexbuf

let _ =
  
  try
    let filename = Sys.argv.(1) in
    let ast = (read_file filename) in

    Printf.printf "Hello, world!\n"

  
  with
      Failure s ->
        (Printf.fprintf stderr "failure: %s\n" s); (exit ~-1)
    | Invalid_argument s ->
        (Printf.fprintf stderr "usage: compiler filename\n\n"); (exit ~-1)
    | Lexer.Eof ->
        (Printf.fprintf stderr "error: unexpected end of file\n"); (exit ~-1)
    | Parsing.Parse_error ->
        (Printf.fprintf stderr "error: syntax error at line %d\n" !line_number); (exit ~-1)

