
open Hd_bundle
open Utils
open Printf

module type DominationSig =
sig
  type quadtype
  type bundletype
  val dominated : quadtype -> bundletype -> quadtype option
end


module Domination =
  functor(Bundle : BundleSig) ->
struct

  type bundletype = Bundle.quadtype list
  and quadtype = Bundle.quadtype
                 
  let dominated qd bundle = 
    try 
      Some(List.find
              (fun qd2 ->
                 (Bundle.label qd)    = "in"               &&
                 (Bundle.label qd2)   = "bin"              &&
                 (Bundle.target qd2)  = (Bundle.target qd) &&
                 (Bundle.subj qd2)    = (Bundle.subj qd)   &&
		 (((Bundle.sigma qd) = (Bundle.sigma qd2)) ||
		  ((List.mem 0 (Bundle.sigma qd2)) && 
		   (let idx = (index 0 (Bundle.sigma qd) (Bundle.obj qd)) - 1 in
		       ((List.nth (Bundle.sigma qd2) idx) = 0) &&
		       List.fold_left
			 (fun b i ->
			    if i <> idx
			    then b && ((List.nth (Bundle.sigma qd) i) = (List.nth (Bundle.sigma qd2) i))
			    else b)
			 true
			 (range 0 (List.length (Bundle.sigma qd2)))))))
              bundle)
    with Not_found -> None

end

