
open Hdxml;;
open Pxp_types;;
open Pxp_document;;
open Pxp_yacc;;
open World;;

(* reducer *)
open Reducer

open Hd_block
open Hd_bisimulation
open Hd_automaton
open Hd_domination

module HDBisimulation = Bisimulation (HDBundle)
module HDBlock = Block (HDState) (HDArrow) (HDBundle) (HD) (HDBisimulation)
module HDDomination = Domination (HDBundle)
module HDReducer = Reducer (HDState) (HDArrow) (HDBundle) (HD) (HDBisimulation) (HDBlock) (HDDomination)

let main() =
  let file = (from_channel stdin) in    
      (* Printf.fprintf stdout "Mihda XML - Version 0.2\n(C) 2002,2003 by Dipartimento di Informatica di Pisa\n\n"; *)
      let hda = parse_hdxml file in
      (* starts reduction *)
      let reduced_automaton = HDReducer.reduce hda in 
	 print_hdxml stdout reduced_automaton
;;


main();;

