(*s Automata may contain transitions
  * that are "redundant", in the sense that, a transition [t]
  * represent a state change (with a given observation) that
  * is semantically covered by another transition [t'].
  * We say that [t'] dominates [t].
  * The module [Domination] defines the interface for such
  * dominance relation.
 *)
module type Domination =
sig

  (*s is the type of quadruples.
   *)
  type quadtype

  (*s returns [Some(qd')] if [qd'] is in [bundle] and dominates [qd],
    * otherwise, [None] is returned.
   *)
  val dominated : qd:quadtype -> bundle:(quadtype list) -> quadtype option

end
